<?php

require_once __DIR__ . '/../../../config/config.php';

if (isset($_ENV['SOAP_URL'])) {
  $url = $_ENV['SOAP_URL'];
} else if (isset($_ENV['SOLO_DOCKER'])) {
  $url = "http://host.docker.internal:8888/ws/subscription";
} else {
  $url = "http://localhost:8888/ws/subscription";
}
$request_param = '<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Body>
  <getAllRequest xmlns="http://services.appnote/">
      <arg0 xmlns="">'. $_ENV['PHP_API_KEY'] . '</arg0>
  </getAllRequest>
</soap:Body>
</soap:Envelope>
';

$headers = array(
  "Content-Type: text/xml;charset=\"utf-8\"",
  'Content-Length: ' .strlen($request_param),
  'X-API-Key: ' . $_ENV['PHP_API_KEY']
);

$ch = curl_init();
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
curl_setopt($ch, CURLOPT_POSTFIELDS, $request_param);
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

$response = curl_exec($ch);
curl_close($ch);
if ($response === FALSE) {
  printf("CURL error (#%d): %s<br>\n", curl_errno($ch),
  htmlspecialchars(curl_error($ch)));
}
$response = trim($response); // Remove leading/trailing whitespace

// Remove any extra content after </S:Envelope>
$response = preg_replace('/<\/S:Envelope>.*$/s', '</S:Envelope>', $response);

$doc = new DOMDocument();
$doc->loadXML($response);

// Mendapatkan semua elemen 'return'
$returns = $doc->getElementsByTagName('return');

$data = array();
foreach ($returns as $return) {
    // Mendapatkan elemen-elemen di dalam 'return'
    $status = $return->getElementsByTagName('status')->item(0)->nodeValue;
    $userId = $return->getElementsByTagName('userId')->item(0)->nodeValue;

    // Menambahkan ke dalam array data
    $data[] = array('status' => $status, 'userId' => $userId);
}

// Menghasilkan format JSON yang diinginkan
$result = json_encode(array('data' => $data));

// Mengirimkan response JSON
http_response_code(200);
echo $result;
