<?php
require_once __DIR__ . '/../models/TagsModel.php';
require_once __DIR__ . '/../models/Notes.php';
require_once __DIR__ . '/../models/reminderModel.php';

// class Admin extends Controller {
//   public function index() {
//     if(isset($_SESSION['is_admin'])){
//       if ($_SESSION['is_admin'] == 1) {
//         $this->view('admin/index');
//       } else {
//         header('Location: /?home');
//       }
//     }
//     else {
//       header('Location: /?home');
//     }
//   }
// }

class Admin extends Controller {
  public function __construct() {
    // Pemeriksaan is_admin di sini
    if (!isset($_SESSION['is_admin']) || $_SESSION['is_admin'] != 1) {
      header('Location: /?home');
    }
  }
  
  public function index() {
    $is_admin = $_SESSION['is_admin'];
    $this->view('admin/index', array('is_admin' => $is_admin));    
  }

  public function searchnotes($user_id = 2, $path = "&page=1") {
    $tag_model = new TagsModel();

    $allTagsData = $tag_model->getAllTags();
    $is_admin = $_SESSION['is_admin'];
    $this->view('notes/index', array('path' => $path, 'allTagsData' => $allTagsData, 'user_id' => $user_id, 'is_admin' => $is_admin));
  }

  public function assess() {
    $is_admin = $_SESSION['is_admin'];
    $this->view('admin/assess');
  }

  public function notecontent($id) {
    $is_admin = $_SESSION['is_admin'];
    $this->view('notes/content', array('id' => $id, 'is_admin' => $is_admin));
  }

  public function editnote($id) {
    $tag_model = new TagsModel();

    $allTagsData = $tag_model->getAllTags();
    // $user_id = $_SESSION['user_id'];
    $is_admin = $_SESSION['is_admin'];
    $this->view('notes/editnote', array('id' => $id, 'allTagsData' => $allTagsData, 'is_admin' => $is_admin));
  }

  public function addnote($user_id) {
    $tag_model = new TagsModel();
    $note_model = new NoteModel();

    $allTagsData = $tag_model->getAllTags();
    $next_id = $note_model->getLatestNoteId($user_id);
    $is_admin = $_SESSION['is_admin'];
    $this->view('notes/addnote', array('next_id' => $next_id->note_id, 'allTagsData' => $allTagsData, 'user_id' => $user_id, 'is_admin' => $is_admin));
  }

  public function reminder($user_id) {
    $reminder_model = new ReminderModel();
    $tag_model = new TagsModel();

    // $user_id = $_SESSION['user_id'];
    
    $allRemindersData = $reminder_model->getReminderByUserId($user_id);
    $allTagsData = $tag_model->getAllTags();
    $is_admin = $_SESSION['is_admin'];
    foreach ($allRemindersData as $reminder){
      $category = $reminder_model->getCategoryByReminderId($reminder->reminder_id);
      $reminder->category = $category;
    }
    $this->view('reminder/index', ['allRemindersData' => $allRemindersData, 'allTagsData' => $allTagsData, 'user_id' => $user_id, 'is_admin' => $is_admin]);
  }

  public function edituser($user_id) {
    $reminder_model = new ReminderModel();
    $tag_model = new TagsModel();
    
    $allRemindersData = $reminder_model->getReminderByUserId($user_id);
    $allTagsData = $tag_model->getAllTags();

    foreach ($allRemindersData as $reminder){
      $category = $reminder_model->getCategoryByReminderId($reminder->reminder_id);
      $reminder->category = $category;
    }
    $this->view('profilepage/index', ['allRemindersData' => $allRemindersData, 'allTagsData' => $allTagsData, 'user_id' => $user_id]);
  }

}