<?php

class App {
    protected $controller = 'Home';
    protected $method = 'index';
    protected $params = [];

    public function __construct(){
        $url = $this->parseURL();
        if ((!isset($_SESSION['username']) && !isset($_COOKIE['GUEST'])) && !empty($url) && $url[0] != 'register'){
            $this->controller = 'Login';
        } else {
            if (file_exists('app/controllers/' . $url[0] . '.php')) {
                $this->controller = $url[0];
                unset($url[0]);
            }
            else if ($url[0] == '') {
                $this->controller = 'Login';
            }
            else {
                $this->controller = 'Errors';
            }
        }
        require_once 'app/controllers/' . $this->controller . '.php';
        $this->controller = new $this->controller;
        if (isset($url[1])) {
            if (method_exists($this->controller, $url[1])) {
                $this->method = $url[1];
                unset($url[1]);
        }
        }
        if ($url) {
            $this->params = array_values($url);
        }
        call_user_func_array([$this->controller, $this->method], $this->params);

    }

    public function parseUrl(){
        if (isset($_SERVER['REQUEST_URI'])) {
            $url = rtrim($_SERVER['REQUEST_URI'], '/');
            $url = ltrim($url, 'public/');
            $url = filter_var($url, FILTER_SANITIZE_URL);
            $url = ltrim($url, '?');
            $url = explode('/', $url);
            return $url;
        }
    }
}