<?php

require_once __DIR__ . '/Database.php';

class DataSeeder {
    public function seedDatas() {
        $database = new Database();

        $database->query("INSERT INTO users (username, email, password, is_admin) VALUES (:username, :email, :password, :is_admin) ON CONFLICT (username) DO NOTHING");
        $database->bind(':username', 'user1');
        $database->bind(':email', 'user1@example.com');
        $database->bind(':password', password_hash('password123', PASSWORD_DEFAULT));
        $database->bind(':is_admin', false);
        $database->execute();

        $database->query("INSERT INTO users (username, email, password, is_admin) VALUES (:username, :email, :password, :is_admin) ON CONFLICT (username) DO NOTHING");
        $database->bind(':username', 'useradmin');
        $database->bind(':email', 'useradmin@example.com');
        $database->bind(':password', password_hash('password123', PASSWORD_DEFAULT));
        $database->bind(':is_admin', true);
        $database->execute();

        $database->query("INSERT INTO users (username, email, password, is_admin) VALUES (:username, :email, :password, :is_admin) ON CONFLICT (username) DO NOTHING");
        $database->bind(':username', 'user3');
        $database->bind(':email', 'user3@example.com');
        $database->bind(':password', password_hash('password123', PASSWORD_DEFAULT));
        $database->bind(':is_admin', false);
        $database->execute();

        // Seed tags table
        $tags = ['All', 'Internship', 'University', 'Hobby'];
        foreach ($tags as $tag) {
            $database->query("INSERT INTO tags (tag_name) VALUES (:tag_name) ON CONFLICT (tag_name) DO NOTHING");
            $database->bind(':tag_name', $tag);
            $database->execute();
        }

        $remindersData = [
            [
                'user_id' => 1,
                'title' => 'Reminder 1',
                'deadline' => '14 Sep 2023 12:00',
                'tasks' => 'Task for reminder 1',
                'category' => 'Internship',
            ],
            [
                'user_id' => 1,
                'title' => 'Reminder 2',
                'deadline' => '10 Sep 2023 12:00',
                'tasks' => 'Task for reminder 1',
                'category' => 'Internship',
            ],
            [
                'user_id' => 1,
                'title' => 'Reminder 3',
                'deadline' => '12 Sep 2023 12:00',
                'tasks' => 'Task for reminder 1',
                'category' => 'Internship',
            ],
            [
                'user_id' => 1,
                'title' => 'Reminder 4',
                'deadline' => '10 Oct 2023 12:00',
                'tasks' => 'Task for reminder 1',
                'category' => 'University',
            ],
        ];
        

        foreach ($remindersData as $reminder) {
            $database->query("SELECT reminder_id FROM reminders WHERE user_id = :user_id AND title = :title AND deadline = :deadline AND tasks = :tasks");
            $database->bind(':user_id', $reminder['user_id']);
            $database->bind(':title', $reminder['title']);
            $database->bind(':deadline', $reminder['deadline']);
            $database->bind(':tasks', $reminder['tasks']);

            $result = $database->fetch();

            if ($result) {
                continue;
            }

            $database->query("INSERT INTO reminders (user_id, title, deadline, tasks) VALUES (:user_id, :title, :deadline, :tasks)");
            $database->bind(':user_id', $reminder['user_id']);
            $database->bind(':title', $reminder['title']);
            $database->bind(':deadline', $reminder['deadline']);
            $database->bind(':tasks', $reminder['tasks']);

            $database->execute();

            $reminderId = $database->lastInsertId();

            $database->query("INSERT INTO category_reminders (category_name, reminder_id) VALUES (:category_name, :reminder_id)");
            $database->bind(':category_name', $reminder['category']);
            $database->bind(':reminder_id', $reminderId);
            $database->execute();
        }

        $imagePath = "../../../storage/note/img/pop.png";
        $videoPath = "../../../storage/note/vid/Visualisasi mimpi.mp4";
        $user_id = 3;
        $tag_name = "University";

        // for ($i = 0; $i < 10000; $i++) {
            
        //     $title = "Dummy Note $i";
        //     $content = "This is a dummy note content for reminder $i.";

        //     $database->query("INSERT INTO notes (user_id, title, content, image_path, video_path) VALUES (:user_id, :title, :content, :image_path, :video_path)");
        //     $database->bind(':user_id', $user_id);
        //     $database->bind(':title', $title);
        //     $database->bind(':content', $content);
        //     $database->bind(':image_path', $imagePath);
        //     $database->bind(':video_path', $videoPath);
        //     $database->execute();

        //     $NoteId = $database->lastInsertId();

        //     $database->query("INSERT INTO tag_notes (tag_name, note_id) VALUES (:tag_name, :note_id)");
        //     $database->bind(':tag_name', $tag_name);
        //     $database->bind(':note_id', $NoteId);
        //     $database->execute();

        // }
    }
}
