<?php

class Tables{
    public const USER_TABLE =
    "CREATE TABLE IF NOT EXISTS users (
        user_id     SERIAL          PRIMARY KEY,
        username    VARCHAR(256)    UNIQUE NOT NULL,
        email       VARCHAR(256)    UNIQUE NOT NULL,
        password    VARCHAR(256)    NOT NULL,
        is_admin    BOOLEAN         NOT NULL
    );";

    public const NOTE_TABLE =
    "CREATE TABLE IF NOT EXISTS notes (
        note_id     SERIAL          PRIMARY KEY,
        user_id     INT             NOT NULL,
        title       VARCHAR(256)    NOT NULL,
        content     VARCHAR(1024)   NOT NULL,
        image_path  VARCHAR(256)    NOT NULL,
        video_path  VARCHAR(256)    NOT NULL,
        FOREIGN KEY (user_id) REFERENCES users (user_id) ON UPDATE CASCADE ON DELETE CASCADE
    );";

    public const REMINDER_TABLE = 
    "CREATE TABLE IF NOT EXISTS reminders (
        reminder_id SERIAL          PRIMARY KEY,
        user_id     INT             NOT NULL,
        title       VARCHAR(256)    NOT NULL,
        deadline    TIMESTAMP       NOT NULL,
        tasks       VARCHAR(256)    NOT NULL,
        FOREIGN KEY (user_id) REFERENCES users (user_id) ON UPDATE CASCADE ON DELETE CASCADE
    );";

    public const TAG_TABLE = 
    "CREATE TABLE IF NOT EXISTS tags (
        tag_name    VARCHAR(256)    PRIMARY KEY
    );";

    public const TAG_NOTE_TABLE = 
    "CREATE TABLE IF NOT EXISTS tag_notes (
        tag_name    VARCHAR(256),
        note_id     INT,
        PRIMARY KEY (tag_name, note_id),
        FOREIGN KEY (tag_name) REFERENCES tags (tag_name) ON UPDATE CASCADE ON DELETE CASCADE,
        FOREIGN KEY (note_id) REFERENCES notes (note_id) ON UPDATE CASCADE ON DELETE CASCADE
    );";

    public const CATEGORY_REMINDER_TABLE = 
    "CREATE TABLE IF NOT EXISTS category_reminders (
        category_name    VARCHAR(256),
        reminder_id      INT,
        PRIMARY KEY (category_name, reminder_id),
        FOREIGN KEY (category_name) REFERENCES tags (tag_name) ON UPDATE CASCADE ON DELETE CASCADE,
        FOREIGN KEY (reminder_id) REFERENCES reminders (reminder_id) ON UPDATE CASCADE ON DELETE CASCADE
    );";
}