<?php
require_once __DIR__ .'/../../config/config.php';
require_once __DIR__ .'/../../app/core/Database.php';
class CategoryRemindersModel
{
  private $table = 'category_reminders';
  private $db;

  public function __construct()
  {
    $this->db = new Database;
  }

  public function getAllCategoryReminders()
  {
    $this->db->query('SELECT * FROM ' . $this->table);
    return $this->db->fetchAll();
  }
  public function getReminderByCategory($category_name)
  {
    $this->db->query('SELECT * FROM ' . $this->table . ' WHERE category_name = :category_name');
    $this->db->bind('category_name', $category_name);
    return $this->db->fetchAll();
  }

  public function insertReminderCategory($data)
  {
    $this->db->query('INSERT INTO ' . $this->table . ' (category_name, reminder_id) VALUES (:category_name, :reminder_id)');
    
    $this->db->bind('category_name', $data['category']);
    $this->db->bind('reminder_id', $data['reminder_id']);

    $this->db->execute();

    return $this->db->rowCount();
  }

  public function deleteReminderCategory($data)
  {
    $this->db->query('DELETE FROM ' . $this->table . ' WHERE reminder_id = :reminder_id AND category_name = :category_name');
    
    $this->db->bind('category_name', $data['category']);
    $this->db->bind('reminder_id', $data['reminder_id']);

    $this->db->execute();

    return $this->db->rowCount();
  }
  public function updateReminderCategory($data)
  {
    $this->db->query('UPDATE ' . $this->table . ' SET category_name = :category_name WHERE reminder_id = :reminder_id');
    
    $this->db->bind('category_name', $data['category']);
    $this->db->bind('reminder_id', $data['reminder_id']);

    $this->db->execute();

    return $this->db->rowCount();
  }


}