<?php
    include_once 'app/core/Database.php';
?>

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title> NotesApp </title>
        <link rel="stylesheet" href="../../../public/css/addnote.css" />
        <!-- <link rel="stylesheet" href="../../../public/css/styles.css" /> -->
        <link 
            rel="stylesheet" 
            href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css" 
            integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA==" 
            crossorigin="anonymous" 
            referrerpolicy="no-referrer" 
        />
        <!-- <script src="../../../public/js/utility.js"></script> -->
        <script src="../../public/js/noteupload.js"></script>
        <!-- <script src="../../../public/js/navbar.js"></script> -->
    </head>

    <body>
        <div class="navbar">
            <?php
                include(__DIR__ . '/../navbar/navbar.php');
            ?>
        </div>
        <div class="main-container">
            <div class="top-buttons">
                <div class="back-button" onclick=backSave() onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">
                    <button class="search-button" onclick=backSave() onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">
                        <i class="fa-solid fa-chevron-left"></i>
                    </button>
                    <div class="back"> Back </div>
                </div>
            </div>
            <div class="new-note-title">
                New note
            </div>
            <div class="note-data-cont">
                <div class="note-text-cont">
                    <div class="text-input-cont">
                        <input type="text" name="text-input" class="text-input" placeholder="Note title">
                    </div>
    
                    <div class="textarea-input-cont">
                        <textarea name="textarea-input" class="textarea-input" placeholder="Note content"></textarea>
                    </div>
                </div>
                <div class="tags-media-cont">
                    <div class="tags-section-cont">
                        <div class="tags-button-cont">
                            <button class="tags-button" onclick=toggleChooseTag() onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">
                                <i class="fa-solid fa-tags"></i>
                                Tags
                            </button>
                        </div>
                        <div id="tags-cont">
                        </div>
                        <div class="tags-list-container" style="display: none;">
                            <?php
                                $tags = $data['allTagsData'];
                                foreach ($tags as $tag) {
                                    if ($tag->tag_name != 'All') {
                                        echo '<div class="tag" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)" onclick="chooseTag(\'' . $tag->tag_name . '\')">' . $tag->tag_name . '</div>';
                                    }
                                }
                            ?>
                        </div>
                    </div>

                    <div class="media-section-cont">
                        <div class="thumbnail-cont">
                            <!-- Input Unggah Thumbnail -->
                            <div class="upload-thumbnail">
                                <input type="file" id="thumbnail-upload" accept="image/*" hidden>
                                <label for="thumbnail-upload" class="upload-button">
                                    <div class="thumbnail-upload-button">
                                        <i class="fa-solid fa-upload"></i> Upload Thumbnail
                                    </div>
                                </label>
                            </div>
    
                            <!-- Tampilkan Thumbnail yang Diunggah -->
                            <div class="note-thumbnail">
                                <img src="#" alt="Thumbnail" id="uploaded-thumbnail-img">
                                <div id="uploaded-thumbnail-div">
                                    Note Thumbnail
                                </div>
                            </div>
                        </div>

                        <div class="video-cont">
                            <!-- Input Unggah Video -->
                            <div class="upload-video">
                                <input type="file" id="video-upload" accept="video/*" hidden>
                                <label for="video-upload">
                                    <div class="video-upload-button">
                                        <i class="fa-solid fa-upload"></i> Upload Video
                                    </div>
                                </label>
                            </div>
    
                            <!-- Tampilkan Video yang Diunggah -->
                            <div class="note-video">
                                <video controls width="100%" height="auto" id="uploaded-video-vid-cont">
                                    <source src="#" id="uploaded-video-vid" type="video/mp4">
                                </video>
    
                                <div id="uploaded-video-div">
                                    Note Video
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="add-note" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)" onclick="saveNote(<?php echo $data['user_id'] ?>, <?php echo $_SESSION['is_admin'] ?>)" >
                    <!-- <div class="add-note" onclick="saveNote()"> -->
                        <i class="fa-solid fa-plus"></i>
                        Add Note
                    </div>
                </div>

            </div>
        <div>
          <script>
            // Unggah Video
            const videoUploadInput = document.getElementById('video-upload');
            const uploadedVideoVidCont = document.getElementById('uploaded-video-vid-cont');
            const uploadedVideoVid = document.getElementById('uploaded-video-vid');
            const uploadedVideoDiv = document.getElementById('uploaded-video-div');

            videoUploadInput.addEventListener('change', function() {
                const file = videoUploadInput.files[0];
                if (file) {
                    // Buat URL objek untuk video yang diunggah
                    const videoURL = URL.createObjectURL(file);
                    // uploadedVideo.src = videoURL;
                    uploadedVideoVidCont.src = videoURL;
                    uploadedVideoVid.style.display = 'block';
                    uploadedVideoVidCont.style.display = 'block';
                    uploadedVideoDiv.style.display = 'none';
                }
            });

            // Unggah Thumbnail
            const thumbnailUploadInput = document.getElementById('thumbnail-upload');
            const uploadedThumbnailImg = document.getElementById('uploaded-thumbnail-img');
            const uploadedThumbnailDiv = document.getElementById('uploaded-thumbnail-div');

            thumbnailUploadInput.addEventListener('change', function() {
                const file = thumbnailUploadInput.files[0];
                if (file) {
                    // Buat URL objek untuk thumbnail yang diunggah
                    const thumbnailURL = URL.createObjectURL(file);
                    uploadedThumbnailImg.src = thumbnailURL;
                    uploadedThumbnailImg.style.display = 'block';
                    uploadedThumbnailDiv.style.display = 'none';
                }
            });

            // // Menggantikan karakter Enter dengan elemen <br/> (seperti yang telah dijelaskan sebelumnya)
            // const noteContent = document.querySelector('.note-content');
            // noteContent.innerHTML = noteContent.innerHTML.replace(/\n/g, '<br/>');
          </script>

        </div>
    </body>
</html>