<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Reminder</title>
    <link rel="stylesheet" href="../../../public/css/reminder.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css">
  </head>
  <body>
    
    <div class="navbar">
        <?php
            include(__DIR__ . '/../navbar/navbar.php');
        ?>
    </div>

    <div class="reminder flex-column align-center">

        <div class="search flex-row align-center">
            <div class="search-1 flex-row box align-center">
                <div class="searchbar">
                    <input type="text" placeholder="Search..." id="searchInput" />
                </div>
                <?php
                    $user_id = $data['user_id'];

                    echo '<div class="time-filter flex-row box align-center" onclick="toggleSort(\'' . $user_id . '\')" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">'
                ?>
                    <div class="text">Time</div>
                    <i class="fas fa-angle-up" id="sortIcon"></i>

                </div>
                <div class="category-filter flex-row box align-center" onclick="toggleCategoryList()" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">
                    <div class="text" id="category-title">Category</div>
                    <i class="fas fa-tags"></i>
                </div>
                <div class="category-list flex-column">
                    <?php
                    $categories = $data['allTagsData'];
                    foreach ($categories as $category) {
                        echo '<div class="category" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)" onclick="filterByCategory(\'' . $category->tag_name . '\')">' . $category->tag_name . '</div>';
                    }
                    ?>
                </div>

            </div>
            <div class="add-button flex-row box align-center" onclick="addReminder()" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">
                <i class="fas fa-plus"></i>
                <div class="text">Reminders</div>
            </div>
        </div>

        <div class="reminders-content">
            <?php

            $itemCount = 0;

            echo '<div class="reminder-row">';
            $reminders = $data['allRemindersData'];
            foreach ($reminders as $reminder) {
                $deadlineDateDisplay = date('d M Y H:i', strtotime($reminder->deadline));
                echo '<div class="reminder-item box " onclick="getReminderContent(\'' . $reminder->reminder_id . '\')" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">';
                echo '<div class="content-title text">' . $reminder->title . '</div>';
                $contentText = $reminder->tasks;
                if (strlen($contentText) > 110) {
                    $contentText = substr($contentText, 0, 110) . '...';
                }
                echo '<p class="content-text text">' . $contentText . '</p>';
                echo '<div class="deadline-category-box flex-row align-bottom align-center">';
                echo '<div class="content-deadline text box">' . $deadlineDateDisplay  . '</div>';
                echo '<div class="content-category">' . $reminder->category->category_name . '</div>'.'</div>';
                echo '</div>';

                $itemCount++;

                if ($itemCount % 3 === 0) {
                    echo '</div>';
                    if ($itemCount < count($reminders)) {
                        echo '<div class="reminder-row">';
                    }
                }
            }

            if ($itemCount % 3 !== 0) {
                echo '</div>';
            }
            ?>
        </div>

        <div class="popup-cover" id="popup-cover"></div>

        <div class="popup flex-column" id="popup">
            <div class="popup-header flex-row">
                <i class="fas fa-id-card fa-2x"></i>
                <div class = "h2 semi-bold popup-title-input box" id="popup-title-input" contentEditable="false"></div>
                <div class = "h2 semi-bold popup-title" id="popup-title">Title</div>
                <div class="edit-icon flex-row">
                    <i class="fas fa-pen fa-2x" id="edit-icon" onclick="editReminder()" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)"></i>
                    <i class="fas fa-trash fa-2x" id="trash-icon" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)"></i>
                    <img class="icon-popup" id="close-icon" src="../../../public/images/xmark.svg" onclick="closePopup()" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)" />
                </div>
            </div>
            <div class="popup-category-deadline flex-row">
                <div class="popup-category flex-column">
                    <div class="popup-category-1 relative">Category</div>
                    <div class="content-category-input align-center" id="popup-category-2-input" onclick="toggleCategoryListInput()" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)"></div>
                    <div class="content-category relative" id="popup-category-2">Category</div>
                </div>
                <div class="popup-deadline flex-column">
                    <div class="popup-deadline-1 relative">Deadline</div>
                    <input type="datetime-local" class="content-deadline-input text box" id="popup-deadline-2-input">
                    <div class="content-deadline text box" id="popup-deadline-2">Deadline</div>
                </div>
            </div>
            <div class="popup-body-header flex-row align-center">
                <i class="fas fa-newspaper fa-2x"></i>
                <div class = "h2 semi-bold popup-task">Task</div>
            </div>
            <div class="popup-body">
                <div class="popup-text-input box overflow-y" id="popup-text-input"></div>
                <div class="popup-text overflow-y" id="popup-text">task</div>
            </div>
            <?php
                $user_id = $data['user_id'];
                echo '<div class="add box" id="add" onclick="add(\'' . $user_id . '\')" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">Submit</div>';
            ?>
            <div class="submit box" id="submit" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">Submit</div>
        </div>

        <div class="category-list-input flex-column">
            <?php
            foreach ($categories as $category) {
                echo '<div class="category" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)" onclick="filterByCategoryInput(\'' . $category->tag_name . '\')">' . $category->tag_name . '</div>';
            }
            ?>
        </div>

        <div class="popup-alert" id="popup-alert">
            <div class="flex-column align-center">
                <i class="fas fa-triangle-exclamation" id="alertIcon"></i>
                <p class="text">Apakah Anda yakin mau menghapus ini?</p>
                <div class="flex-row align-center confirm-buttons">
                    <button class="box align-center hapus" id="hapus" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">Hapus</button>
                    <button class="box align-center batal" id="batal" onmouseover="setCursorPointer(this)" onmouseout="resetCursor(this)">Batal</button>
                </div>
            </div>
        </div>
    </div>

    <script src="../../../public/js/reminder.js"></script>
  </body>
</html>
