const fillRequestTable = () => {
  const xhr = new XMLHttpRequest();
  xhr.open("GET", '../../app/api/premium/getAllRequest.php', true);

  xhr.onload = function () {
    if (this.status == 200) {
      let response = JSON.parse(this.responseText);
      // let userTableCont = document.getElementsByClassName("user-table-container");
      const userTableCont = document.querySelector(".user-table-container");
      userTableCont.innerHTML = `            
          <div class="table-header-row-container">
              <div class="user-id">
                  User ID
              </div>

              <div class="status">
                  Status
              </div>
          </div>
      `
      if (response["data"] == "[]") {
        userTableCont.innerHTML = `
          <p>Sorry, no request found :(</p>
        </div>`;
      } else {
        response.data.forEach((user) => {
          userTableCont.innerHTML += `
              <div class="row-container">
                  <div class="id-col-container">
                      ${user.userId}
                  </div>
                  <button onclick="acceptRequest(${user.userId})" class="accept-col-container">
                      Accept
                  </button>
                  <button onclick="rejectRequest(${user.userId})" class="reject-col-container">
                      Reject
                  </button>
              </div>
          `;
        });
      }
    } else {
      alert(response);
      alert("failed to get request informations");
    }
  };
  xhr.send();
};

const acceptRequest = (userId) => {
  const data = new FormData();
  data.append("user_id", userId);

  const xhr = new XMLHttpRequest();
  xhr.open("POST", "../../app/api/premium/approveRequest.php", true);
  xhr.onload = function () {
    if (xhr.readyState == 4 && xhr.status == 200) {
      const response = xhr.responseText;

      if (response.includes("Request accepted")) {
        alert("Request accepted");
        
        const updateUserPremiumStatusXHR = new XMLHttpRequest();
        updateUserPremiumStatusXHR.open("POST", "../../app/api/premium/updateUserPremiumStatus.php", true);
        updateUserPremiumStatusXHR.onload = function() {
          if (updateUserPremiumStatusXHR.readyState == 4 && updateUserPremiumStatusXHR.status == 200) {
            console.log("User premium status updated");
          } else {
            console.error("Failed to update user premium status");
          }
        };
        updateUserPremiumStatusXHR.send(data);
        
        window.location.href = "/?admin/assess";
      } else if (response.includes("Request already accepted")) {
        alert("Request already accepted");
      } else if (response.includes("Request already rejected")) {
        alert("Request already rejected");
      } else if (response.includes("Request not found")) {
        alert("Request not found");
      } else {
        alert("Failed to accept request");
      }
    } else {
      alert("Failed to accept request");
    }
  };

  xhr.send(data);
};

const rejectRequest = (userId) => {
  const data = new FormData();
  data.append("user_id", userId);

  const xhr = new XMLHttpRequest();
  xhr.open("POST", "../../app/api/premium/rejectRequest.php", true);
  xhr.onload = function () {
    if (xhr.readyState == 4 && xhr.status == 200) {
      const response = xhr.responseText;

      if (response.includes("Request rejected")) {
        alert("Request rejected");
        window.location.href = "/?admin/assess";
      } else if (response.includes("Request already accepted")) {
        alert("Request already accepted");
        // Lakukan tindakan tambahan jika diperlukan
      } else if (response.includes("Request already rejected")) {
        alert("Request already rejected");
        // Lakukan tindakan tambahan jika diperlukan
      } else if (response.includes("Request not found")) {
        alert("Request not found");
        // Lakukan tindakan tambahan jika diperlukan
      } else {
        alert("Failed to accept request");
      }
    } else {
      alert('Failed to reject request');
    }
  }

  xhr.send(data);
}
