function backContent () {
  window.history.back();
}

function editNote(noteId, isAdmin) {
  if (isAdmin) {
    window.location.href = "/?admin/editnote/" + noteId;
  } else {
    window.location.href = "/?notes/edit/" + noteId;
  }
};

// Fungsi untuk mengisi informasi catatan
function fillNoteContent(data) {
  const noteTitle = document.querySelector('.note-title');
  const noteContent = document.querySelector('.note-content');
  const tags = document.querySelector('.tags');
  const video = document.querySelector('video');

  // Isi judul catatan
  noteTitle.textContent = data.title;

  // Isi isi catatan (content)
  noteContent.innerHTML = data.content;

  // Isi tag-tag catatan
  tags.innerHTML = '';
  
  data.tags.forEach((tag) => {
    const tagElement = document.createElement('div');
    tagElement.classList.add('tag');
    tagElement.textContent = tag.tag_name;
    tags.appendChild(tagElement);
  });

  // Isi video catatan
  if (data.video_path) {
    video.src = data.video_path;
    video.style.display = 'block';
  } else {
    video.style.display = 'none';
  }

  // Memuat video baru
  video.load();
}

// Fungsi untuk mendapatkan informasi catatan dari server
function getNoteContent(noteId) {
  const xhr = new XMLHttpRequest();
  const requestURL = '../../app/api/notes/detail.php?id=' + noteId;
  xhr.open('GET', requestURL, true);

  xhr.onload = function () {
    if (xhr.readyState === 4) {
      if (xhr.status === 200) {
        const responseData = JSON.parse(xhr.responseText);
        fillNoteContent(responseData);
      } else {
        alert('Failed to fetch note content');
      }
    }
  };

  xhr.send();
}
function setCursorPointer(element) {
  element.style.cursor = "pointer";
}

function resetCursor(element) {
  element.style.cursor = "default";
}

// // Panggil fungsi getNoteContent saat halaman dimuat
// const noteId = <?php echo $data['id']; ?>;
// getNoteContent(noteId);
