function openPopup(data) {
    document.getElementById("popup-title").textContent = data.title;
    document.getElementById("popup-text").textContent = data.tasks;
    document.getElementById("popup-deadline-2").textContent = data.deadline;
    document.getElementById("popup-category-2").textContent = data.category.category_name;

    document.getElementById("popup-cover").style.display = "block";
    document.getElementById("popup").style.display = "flex";
    var confirmationButton = document.getElementById('trash-icon');
    confirmationButton.addEventListener("click", function() {
        confirmation(data.reminder_id);
    });
    var submitEditButton = document.getElementById('submit');
    submitEditButton.addEventListener("click", function() {
        submit(data);
    });

}

function confirmation(id){
    document.getElementById("popup-alert").style.display = "flex";
    var deleteButton = document.getElementById('hapus');
    deleteButton.addEventListener("click", function() {
        document.getElementById("popup-alert").style.display = "none";
        deleteReminder(id);
    });
    var cancelButton = document.getElementById('batal');
    cancelButton.addEventListener("click", function(){
        document.getElementById("popup-alert").style.display = "none";
    })
}

function getReminderContent(Id) {
    const xhr = new XMLHttpRequest();
    xhr.open('GET', '../../app/api/reminder/detailReminders.php?id=' + Id, true);
  
    xhr.onreadystatechange = function () {
      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          const responseData = JSON.parse(xhr.responseText);
          openPopup(responseData);
        } else {
          alert('Failed to fetch note content');
        }
      }
    };
  
    xhr.send();
}
  

function closePopup() {
    var popup = document.getElementById('popup');
    var popup_cover = document.getElementById('popup-cover');
    popup.style.display = 'none';
    popup_cover.style.display = 'none';

    document.getElementById("popup-title").style.display = "flex";
    document.getElementById("popup-title-input").style.display = "none";
    document.getElementById("popup-text").style.display = "flex";
    document.getElementById("popup-text-input").style.display = "none";
    document.getElementById("popup-deadline-2").style.display = "flex";
    document.getElementById("popup-deadline-2-input").style.display = "none";
    document.getElementById("popup-category-2").style.display = "flex";
    document.getElementById("popup-category-2-input").style.display = "none";

    document.getElementById("popup-title-input").contentEditable = "false";
    document.getElementById("popup-text-input").contentEditable = "false";
    document.getElementById("popup-deadline-2-input").contentEditable = "false";

    document.getElementById("popup-title-input").textContent = "";
    document.getElementById("popup-text-input").textContent = "" ;
    document.getElementById("popup-deadline-2-input").value = "" ;
    document.getElementById("popup-category-2-input").textContent = "category";

    document.getElementById("edit-icon").style.display = "flex";
    document.getElementById("trash-icon").style.display = "flex";
    document.getElementById("submit").style.display = "none";
    document.getElementById("add").style.display = "none";
    var icon = document.getElementById("close-icon");
    icon.style.marginLeft = "0px";
}

var ascendingOrder = false;
function toggleSort(user_id) {
    ascendingOrder = !ascendingOrder;

    var sortIcon = document.getElementById("sortIcon");
    if (ascendingOrder) {
        sortIcon.classList.remove("fa-angle-down");
        sortIcon.classList.add("fa-angle-up");
    } else {
        sortIcon.classList.remove("fa-angle-up");
        sortIcon.classList.add("fa-angle-down");
    }

    sortReminders(user_id);
}

function sortReminders(user_id) {
    const xhr = new XMLHttpRequest();
    xhr.open('GET', '../../app/api/reminder/sortReminders.php?id=' + user_id, true);
  
    xhr.onreadystatechange = function () {
      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          const responseData = JSON.parse(xhr.responseText);
          sortReminderItemsByDeadline(responseData);
        } else {
          alert('Failed to fetch note content');
        }
      }
    };
  
    xhr.send();
}

function sortReminderItemsByDeadline(data) {

    var dataArray = Object.values(data);

    dataArray.sort(function (a, b) {
        var dateA = new Date(a.deadline);
        var dateB = new Date(b.deadline);

        if (ascendingOrder) {
            return dateA - dateB;
        } else {
            return dateB - dateA;
        }
    });

    var remindersContent = document.querySelector(".reminders-content");

    while (remindersContent.firstChild) {
        remindersContent.removeChild(remindersContent.firstChild);
    }

    var numColumns = 3;
    var numRows = Math.ceil(dataArray.length / numColumns);

    for (var i = 0; i < numRows; i++) {
        var newRow = document.createElement("div");
        newRow.classList.add("reminder-row");
        remindersContent.appendChild(newRow);

        for (var j = 0; j < numColumns; j++) {
            var dataIndex = i * numColumns + j;
            if (dataIndex < dataArray.length) {
                var reminderItem = createReminderItem(dataArray[dataIndex]);
                newRow.appendChild(reminderItem);
            }
        }
    }
}
function createReminderItem(reminderData) {

    var reminderItem = document.createElement("div");
    reminderItem.classList.add("reminder-item", "box");
    reminderItem.addEventListener("click", function() {
        getReminderContent(reminderData.reminder_id);
    });
    reminderItem.addEventListener("mouseover", function() {
        setCursorPointer(this);
    });
    reminderItem.addEventListener("mouseout", function() {
        resetCursor(this);
    });

    var titleElement = document.createElement("div");
    titleElement.classList.add("content-title", "text");
    titleElement.textContent = reminderData.title;

    var contentText = reminderData.tasks.length > 110 ? reminderData.tasks.substring(0, 110) + "..." : reminderData.tasks;
    var contentTextElement = document.createElement("p");
    contentTextElement.classList.add("content-text", "text");
    contentTextElement.textContent = contentText;

    var deadlineDate = new Date(reminderData.deadline);
    var day = deadlineDate.getDate();
    var month = deadlineDate.toLocaleString("default", { month: "short" });
    var year = deadlineDate.getFullYear();
    var hour = deadlineDate.getHours().toString().padStart(2, "0");
    var minute = deadlineDate.getMinutes().toString().padStart(2, "0");

    var deadlineDateDisplay = day + " " + month + " " + year + " " + hour + ":" + minute;
    var deadlineElement = document.createElement("div");
    deadlineElement.classList.add("content-deadline", "text", "box");
    deadlineElement.textContent = deadlineDateDisplay;

    var categoryElement = document.createElement("div");
    categoryElement.classList.add("content-category");
    categoryElement.textContent = reminderData.category.category_name;

    var deadlineCategoryBox = document.createElement("div");
    deadlineCategoryBox.classList.add("deadline-category-box", "flex-row", "align-bottom", "align-center");

    reminderItem.appendChild(titleElement);
    reminderItem.appendChild(contentTextElement);
    deadlineCategoryBox.appendChild(deadlineElement);
    deadlineCategoryBox.appendChild(categoryElement);
    reminderItem.appendChild(deadlineCategoryBox);

    return reminderItem;
}

function setCursorPointer(element) {
    element.style.cursor = "pointer";
}

function resetCursor(element) {
    element.style.cursor = "default";
}

var searchInput = document.getElementById('searchInput');
var reminderItems = Array.from(document.querySelectorAll('.reminder-item'));
var remindersContent = document.querySelector('.reminders-content');
var nowCategory = "All";

function runSearch() {
    var searchText = searchInput.value.toLowerCase();

    var matchingItems = [];
    count = 0;

    reminderItems.forEach(function (item) {
        var title = item.querySelector('.content-title').textContent.toLowerCase();
        var itemCategory = item.querySelector(".content-category").textContent;
        if (title.includes(searchText) && (nowCategory==="All" || itemCategory === nowCategory)) {
            matchingItems.push(item);
            count++;
        } else {}
    });
    while (remindersContent.firstChild) {
        remindersContent.removeChild(remindersContent.firstChild);
    }
    var numColumns = 3;

    for (var i = 0; i < count; i++) {
        var columnIndex = i % numColumns;

        if (columnIndex === 0) {
            var newRow = document.createElement("div");
            newRow.classList.add("reminder-row");
            remindersContent.appendChild(newRow);
        }

        remindersContent.lastChild.appendChild(matchingItems[i]);
    }
}

var originalReminderItems = Array.from(document.querySelectorAll('.reminder-item'));

function filterByCategory(category) {

    nowCategory = category;

    document.getElementById("category-title").textContent = category;

    runSearch();

    var reminderItems = Array.from(document.querySelectorAll('.reminder-item'));

    var remindersContent = document.querySelector('.reminders-content');

    var matchingItems = [];
    count = 0;

    reminderItems.forEach(function(item) {
        var itemCategory = item.querySelector(".content-category").textContent;
        if (category === "All" || itemCategory === category) {
            matchingItems.push(item);
            count++;
        }
    });

    while (remindersContent.firstChild) {
        remindersContent.removeChild(remindersContent.firstChild);
    }

    var numColumns = 3;

    for (var i = 0; i < count; i++) {
        var columnIndex = i % numColumns;

        if (columnIndex === 0) {
            var newRow = document.createElement("div");
            newRow.classList.add("reminder-row");
            remindersContent.appendChild(newRow);
        }

        remindersContent.lastChild.appendChild(matchingItems[i]);
    }
    toggleCategoryList();
}

searchInput.addEventListener('input', runSearch);

function toggleCategoryList() {
    var categoryList = document.querySelector(".category-list");
    categoryList.classList.toggle("active");
}

function addReminder() {
    document.getElementById("popup-title").style.display = "none";
    document.getElementById("popup-title-input").style.display = "flex";
    document.getElementById("popup-text").style.display = "none";
    document.getElementById("popup-text-input").style.display = "flex";
    document.getElementById("popup-deadline-2").style.display = "none";
    document.getElementById("popup-deadline-2-input").style.display = "flex";
    document.getElementById("popup-category-2").style.display = "none";
    document.getElementById("popup-category-2-input").style.display = "flex";

    document.getElementById("popup-title-input").contentEditable = "true";
    document.getElementById("popup-text-input").contentEditable = "true";
    document.getElementById("popup-deadline-2-input").contentEditable = "true";
    document.getElementById("popup-category-2-input").textContent = "category";


    document.getElementById("popup-cover").style.display = "block";
    document.getElementById("edit-icon").style.display = "none";
    document.getElementById("trash-icon").style.display = "none";
    document.getElementById("popup").style.display = "flex";
    document.getElementById("add").style.display = "flex";
    var icon = document.getElementById("close-icon");
    icon.style.marginLeft = "90px";
    
}

function editReminder() {
    document.getElementById("popup-title").style.display = "none";
    document.getElementById("popup-title-input").style.display = "flex";
    document.getElementById("popup-text").style.display = "none";
    document.getElementById("popup-text-input").style.display = "flex";
    document.getElementById("popup-deadline-2").style.display = "none";
    document.getElementById("popup-deadline-2-input").style.display = "flex";
    document.getElementById("popup-category-2").style.display = "none";
    document.getElementById("popup-category-2-input").style.display = "flex";

    document.getElementById("popup-title-input").textContent = document.getElementById("popup-title").textContent ;
    document.getElementById("popup-title-input").contentEditable = "true";
    document.getElementById("popup-text-input").textContent = document.getElementById("popup-text").textContent ;
    document.getElementById("popup-text-input").contentEditable = "true";
    document.getElementById("popup-deadline-2-input").value = document.getElementById("popup-deadline-2").textContent ;
    document.getElementById("popup-deadline-2-input").contentEditable = "true";
    document.getElementById("popup-category-2-input").textContent = document.getElementById("popup-category-2").textContent;

    document.getElementById("popup-cover").style.display = "block";
    document.getElementById("popup").style.display = "flex";
    document.getElementById("submit").style.display = "flex";
    
}

const popupTitleInput = document.getElementById("popup-title-input");

const maxLength = 16;

popupTitleInput.addEventListener("keydown", function(event) {
    const text = popupTitleInput.textContent;
    const length = text.length;

    if (length > maxLength && event.key !== 'Backspace' && event.key !== 'Delete') {
        event.preventDefault();
    }
});

function toggleCategoryListInput() {
    var categoryListInput = document.querySelector(".category-list-input");
    categoryListInput.classList.toggle("active");
}


function filterByCategoryInput(category) {
    var popupCategoryInput = document.getElementById("popup-category-2-input");
    popupCategoryInput.textContent = category;
    toggleCategoryListInput();
}

function add(user_id){
    const title = document.getElementById("popup-title-input").textContent
    const tasks = document.getElementById("popup-text-input").textContent
    const deadline = document.getElementById("popup-deadline-2-input").value
    const category = document.getElementById("popup-category-2-input").textContent

    if (title === "" || tasks === "" || deadline === "" || category === "" || category === "All" || category === "category") {
        alert("Please fill all the field");
        return;
    }

    const data = new FormData();
    data.append("user_id",user_id )
    data.append("title", title);
    data.append("tasks", tasks);
    data.append("deadline", deadline);
    data.append("category", category);

    const xhr = new XMLHttpRequest();
    xhr.open('POST', '../../app/api/reminder/addReminder.php?id=' + user_id, true);
  
    xhr.onload = function () {
        if (this.status === 200) {
            alert("Add reminder success");
            location.reload();
        } else {
            alert(this.responseText);
        }
    };

    xhr.send(data);

    closePopup();
}

function deleteReminder(reminder_id) {

    const xhr = new XMLHttpRequest();
    xhr.open('POST', '../../app/api/reminder/deleteReminder.php?reminder_id=' + reminder_id, true);

    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && xhr.status == 200) {
            if (xhr.status == 200) {
                alert("Reminder removed");
                location.reload();
            }
        }
    }
    const data = new FormData();
    data.append("reminder_id", reminder_id);

    xhr.send(data);
    closePopup();
}
function submit(data){
    const title = document.getElementById("popup-title-input").textContent
    const tasks = document.getElementById("popup-text-input").textContent
    const deadline = document.getElementById("popup-deadline-2-input").value
    const category = document.getElementById("popup-category-2-input").textContent

    if (title === "" || tasks === "" || deadline === "" || category === "" || category === "All" || category === "category") {
        alert("Please fill all the field");
        return;
    }

    const newData = new FormData();
    newData.append("reminder_id", data.reminder_id)
    newData.append("user_id",data.user_id)
    newData.append("title", title);
    newData.append("tasks", tasks);
    newData.append("deadline", deadline);
    newData.append("category", category);

    const xhr = new XMLHttpRequest();
    xhr.open('POST', '../../app/api/reminder/editReminder.php', true);
  
    xhr.onload = function () {
        if (this.status === 200) {
            alert("Edit reminder success");
            var submitEditButton = document.getElementById('submit');
            submitEditButton.removeEventListener("click", function() {
                submit(data);
            });
            location.reload();
        } else {
            alert("Edit reminder failed");
        }
    };

    xhr.send(newData);

    closePopup();
}















